> For the complete documentation index, see [llms.txt](https://docs.nimbalyst.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.nimbalyst.com/open-safe-private-secure/session-and-window-state-storage.md).

# Session and Window State Storage

Session History and Windows State are stored in a local database

#### **Database**

**Database:** PGLite (PostgreSQL in WebAssembly)

**Table:** `ai_sessions`

**Location:** `~/Library/Application Support/@preditor/electron/pglite-db/`

#### Session Data Structure

Each session includes:

```
{
  id: string;              // Unique session ID
  workspacePath: string;   // Workspace this session belongs to
  provider: string;        // AI provider (claude, openai, etc.)
  model: string;           // Model ID
  sessionType: string;     // 'chat' or 'agent'
  messages: Message[];     // Conversation history
  documentContext: object; // Document that was active
  metadata: object;        // Custom metadata
  title: string;           // Session name
  draftInput: string;      // Unsaved user input
  createdAt: number;       // Creation timestamp
  updatedAt: number;       // Last update timestamp
}
```

<br>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.nimbalyst.com/open-safe-private-secure/session-and-window-state-storage.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
